listed_ip = {}
listed_usgn = {}

addhook("join","record_usgn")
addhook("leave","record_usgn")
function record_usgn(id)
	if _plfunc(id,"usgn") > 0 then
		listed_usgn[player(id,"ip")] = _plfunc(id,"usgn")
		listed_ip[player(id,"usgn")] = _plfunc(id,"ip")

		local f
		f = io.open("sys/lua/usgn_records/usgn_".._plfunc(id,"usgn")..".txt", "w")
		if f then
			f:write(player(id,"ip"))
			f:close()
		end

		f = io.open("sys/lua/usgn_records/ip_".._plfunc(id,"ip")..".txt", "w")
		if f then
			f:write(player(id,"usgn"))
			f:close()
		end
	elseif not listed_usgn[player(id,"ip")] then
		load_usgn(player(id,"ip"))
		if listed_usgn[player(id,"ip")] then
			msg2(id, string.char(169).."000255000U.S.G.N Record: Loaded your USGN ID #"..player(id,"usgn"))
		end
	end
end

function load_usgn(ip)
	local f = io.open("sys/lua/usgn_records/ip_"..ip..".txt")
	if f then
		local usgn_id = tonumber(f:read())
		f:close()

		if usgn_id then
			f = io.open("sys/lua/usgn_records/usgn_"..usgn_id..".txt")
			if f then
				local ip_check = f:read()
				f:close()

				if ip_check == ip then
					listed_usgn[ip] = usgn_id
					listed_ip[usgn_id] = ip
				end
			end
		end
	end
end

_plfunc = player
function player(...)
	if #arg >= 2 then
		if type(arg[1]) == "number" and arg[2] == "usgn" then
			local usgn_id = _plfunc(arg[1], "usgn")
			if usgn_id > 0 then
				return usgn_id
			elseif listed_usgn[_plfunc(arg[1],"ip")] then
				return listed_usgn[_plfunc(arg[1],"ip")]
			else
				load_usgn(_plfunc(arg[1], "ip"))

				local usgn_id = listed_usgn[_plfunc(arg[1],"ip")]
				if usgn_id then return usgn_id end
			end
			return 0
		end
	end
	return _plfunc(unpack(arg))
end
